<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - ombs_test_coverage.info - httpserver/http_server.cpp</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">httpserver</a> - http_server.cpp<span style="font-size: 80%;"> (source / <a href="http_server.cpp.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">ombs_test_coverage.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">113</td>
            <td class="headerCovTableEntry">119</td>
            <td class="headerCovTableEntryHi">95.0 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2022-01-07 08:01:00</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">22</td>
            <td class="headerCovTableEntry">22</td>
            <td class="headerCovTableEntryHi">100.0 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span>            : #include &quot;http_server.hpp&quot;</a>
<a name="2"><span class="lineNum">       2 </span>            : </a>
<a name="3"><span class="lineNum">       3 </span>            : #include &quot;mongodb_handler.hpp&quot;</a>
<a name="4"><span class="lineNum">       4 </span>            : #include &quot;net/server.hpp&quot;</a>
<a name="5"><span class="lineNum">       5 </span>            : #include &quot;log.hpp&quot;</a>
<a name="6"><span class="lineNum">       6 </span>            : </a>
<a name="7"><span class="lineNum">       7 </span>            : namespace omsb</a>
<a name="8"><span class="lineNum">       8 </span>            : {</a>
<a name="9"><span class="lineNum">       9 </span>            : </a>
<a name="10"><span class="lineNum">      10 </span>            :   // Constructor</a>
<a name="11"><span class="lineNum">      11 </span><span class="lineCov">          1 :   HttpServer::HttpServer(served::multiplexer multiplexer) : multiplexer(multiplexer)</span></a>
<a name="12"><span class="lineNum">      12 </span>            :   {</a>
<a name="13"><span class="lineNum">      13 </span><span class="lineCov">          1 :     InitializeEndpoints();</span></a>
<a name="14"><span class="lineNum">      14 </span><span class="lineCov">          1 :   }</span></a>
<a name="15"><span class="lineNum">      15 </span>            : </a>
<a name="16"><span class="lineNum">      16 </span>            :   // Public methods</a>
<a name="17"><span class="lineNum">      17 </span><span class="lineCov">          1 :   void HttpServer::StartServer()</span></a>
<a name="18"><span class="lineNum">      18 </span>            :   {</a>
<a name="19"><span class="lineNum">      19 </span><span class="lineCov">          3 :     served::net::server server(ombsIpAddress, ombsPort, multiplexer);</span></a>
<a name="20"><span class="lineNum">      20 </span><span class="lineCov">          1 :     std::cout &lt;&lt; &quot;Starting server to listen on port &quot; &lt;&lt; ombsPort &lt;&lt; &quot;...&quot;</span></a>
<a name="21"><span class="lineNum">      21 </span><span class="lineCov">          1 :               &lt;&lt; std::endl;</span></a>
<a name="22"><span class="lineNum">      22 </span><span class="lineCov">          1 :     server.run(ombsThreads);</span></a>
<a name="23"><span class="lineNum">      23 </span><span class="lineCov">          1 :   }</span></a>
<a name="24"><span class="lineNum">      24 </span>            : </a>
<a name="25"><span class="lineNum">      25 </span>            :   // Private methods</a>
<a name="26"><span class="lineNum">      26 </span><span class="lineCov">          1 :   auto HttpServer::AddMovieToMongoDb()</span></a>
<a name="27"><span class="lineNum">      27 </span>            :   {</a>
<a name="28"><span class="lineNum">      28 </span><span class="lineCov">          1 :     return [&amp;](served::response &amp;response, const served::request &amp;request)</span></a>
<a name="29"><span class="lineNum">      29 </span>            :     {</a>
<a name="30"><span class="lineNum">      30 </span><span class="lineCov">          2 :       MongoDbHandler mhandler;</span></a>
<a name="31"><span class="lineNum">      31 </span>            :       // read the body of request</a>
<a name="32"><span class="lineNum">      32 </span><span class="lineCov">          2 :       json::JSON request_body = json::JSON::Load(request.body());</span></a>
<a name="33"><span class="lineNum">      33 </span><span class="lineCov">          1 :       LOG(</span></a>
<a name="34"><span class="lineNum">      34 </span>            :           &quot; Server Rest API: Request add movie to database movie title = &quot;</a>
<a name="35"><span class="lineNum">      35 </span>            :           &lt;&lt; request_body[&quot;movieTitle&quot;].ToString());</a>
<a name="36"><span class="lineNum">      36 </span>            :       // extract each needed field from the request,  then call MongoDbHandler to add the data</a>
<a name="37"><span class="lineNum">      37 </span><span class="lineCov">          1 :       bool insert_successful = mhandler.AddMovieToDb(request_body[&quot;movieTitle&quot;].ToString());</span></a>
<a name="38"><span class="lineNum">      38 </span>            : </a>
<a name="39"><span class="lineNum">      39 </span><span class="lineCov">          1 :       insert_successful ? served::response::stock_reply(201, response)</span></a>
<a name="40"><span class="lineNum">      40 </span><span class="lineNoCov">          0 :                         : served::response::stock_reply(400, response);</span></a>
<a name="41"><span class="lineNum">      41 </span><span class="lineCov">          2 :     };</span></a>
<a name="42"><span class="lineNum">      42 </span>            :   }</a>
<a name="43"><span class="lineNum">      43 </span>            : </a>
<a name="44"><span class="lineNum">      44 </span><span class="lineCov">          1 :   auto HttpServer::GetAllMovies()</span></a>
<a name="45"><span class="lineNum">      45 </span>            :   {</a>
<a name="46"><span class="lineNum">      46 </span><span class="lineCov">          1 :     return [&amp;](served::response &amp;response, const served::request &amp;request)</span></a>
<a name="47"><span class="lineNum">      47 </span>            :     {</a>
<a name="48"><span class="lineNum">      48 </span><span class="lineCov">          2 :       MongoDbHandler mhandler;</span></a>
<a name="49"><span class="lineNum">      49 </span><span class="lineCov">          1 :       LOG(&quot; Server Rest API: Request all movies&quot;);</span></a>
<a name="50"><span class="lineNum">      50 </span><span class="lineCov">          2 :       const json::JSON &amp;all_documents = mhandler.GetAllMovies();</span></a>
<a name="51"><span class="lineNum">      51 </span><span class="lineCov">          1 :       std::ostringstream stream;</span></a>
<a name="52"><span class="lineNum">      52 </span><span class="lineCov">          1 :       stream &lt;&lt; all_documents;</span></a>
<a name="53"><span class="lineNum">      53 </span><span class="lineCov">          1 :       response &lt;&lt; stream.str();</span></a>
<a name="54"><span class="lineNum">      54 </span><span class="lineCov">          2 :     };</span></a>
<a name="55"><span class="lineNum">      55 </span>            :   }</a>
<a name="56"><span class="lineNum">      56 </span>            : </a>
<a name="57"><span class="lineNum">      57 </span><span class="lineCov">          1 :   auto HttpServer::AddTheaterToMongoDb()</span></a>
<a name="58"><span class="lineNum">      58 </span>            :   {</a>
<a name="59"><span class="lineNum">      59 </span><span class="lineCov">          1 :     return [&amp;](served::response &amp;response, const served::request &amp;request)</span></a>
<a name="60"><span class="lineNum">      60 </span>            :     {</a>
<a name="61"><span class="lineNum">      61 </span><span class="lineCov">          2 :       MongoDbHandler mhandler;</span></a>
<a name="62"><span class="lineNum">      62 </span>            :       // read the body of request</a>
<a name="63"><span class="lineNum">      63 </span><span class="lineCov">          2 :       json::JSON request_body = json::JSON::Load(request.body());</span></a>
<a name="64"><span class="lineNum">      64 </span><span class="lineCov">          1 :       LOG(</span></a>
<a name="65"><span class="lineNum">      65 </span>            :           &quot; Server Rest API: Request add theater to database theater name = &quot;</a>
<a name="66"><span class="lineNum">      66 </span>            :           &lt;&lt; request_body[&quot;theaterName&quot;].ToString());</a>
<a name="67"><span class="lineNum">      67 </span>            :       // extract each needed field from the request,  then call MongoDbHandler to add the data</a>
<a name="68"><span class="lineNum">      68 </span><span class="lineCov">          1 :       bool insert_successful = mhandler.AddTheaterToDb(request_body[&quot;theaterName&quot;].ToString());</span></a>
<a name="69"><span class="lineNum">      69 </span>            : </a>
<a name="70"><span class="lineNum">      70 </span><span class="lineCov">          1 :       insert_successful ? served::response::stock_reply(201, response)</span></a>
<a name="71"><span class="lineNum">      71 </span><span class="lineNoCov">          0 :                         : served::response::stock_reply(400, response);</span></a>
<a name="72"><span class="lineNum">      72 </span><span class="lineCov">          2 :     };</span></a>
<a name="73"><span class="lineNum">      73 </span>            :   }</a>
<a name="74"><span class="lineNum">      74 </span>            : </a>
<a name="75"><span class="lineNum">      75 </span><span class="lineCov">          1 :   auto HttpServer::GetAllTheaters()</span></a>
<a name="76"><span class="lineNum">      76 </span>            :   {</a>
<a name="77"><span class="lineNum">      77 </span><span class="lineCov">          1 :     return [&amp;](served::response &amp;response, const served::request &amp;request)</span></a>
<a name="78"><span class="lineNum">      78 </span>            :     {</a>
<a name="79"><span class="lineNum">      79 </span><span class="lineCov">          2 :       MongoDbHandler mhandler;</span></a>
<a name="80"><span class="lineNum">      80 </span><span class="lineCov">          1 :       LOG(&quot; Server Rest API: Request all theaters&quot;);</span></a>
<a name="81"><span class="lineNum">      81 </span><span class="lineCov">          2 :       const json::JSON &amp;all_documents = mhandler.GetAllTheaters();</span></a>
<a name="82"><span class="lineNum">      82 </span><span class="lineCov">          1 :       std::ostringstream stream;</span></a>
<a name="83"><span class="lineNum">      83 </span><span class="lineCov">          1 :       stream &lt;&lt; all_documents;</span></a>
<a name="84"><span class="lineNum">      84 </span><span class="lineCov">          1 :       response &lt;&lt; stream.str();</span></a>
<a name="85"><span class="lineNum">      85 </span><span class="lineCov">          2 :     };</span></a>
<a name="86"><span class="lineNum">      86 </span>            :   }</a>
<a name="87"><span class="lineNum">      87 </span>            : </a>
<a name="88"><span class="lineNum">      88 </span><span class="lineCov">          1 :   auto HttpServer::AddMovieShowToMongoDb()</span></a>
<a name="89"><span class="lineNum">      89 </span>            :   {</a>
<a name="90"><span class="lineNum">      90 </span><span class="lineCov">          1 :     return [&amp;](served::response &amp;response, const served::request &amp;request)</span></a>
<a name="91"><span class="lineNum">      91 </span>            :     {</a>
<a name="92"><span class="lineNum">      92 </span><span class="lineCov">          2 :       MongoDbHandler mhandler;</span></a>
<a name="93"><span class="lineNum">      93 </span>            :       // read the body of request</a>
<a name="94"><span class="lineNum">      94 </span><span class="lineCov">          2 :       json::JSON request_body = json::JSON::Load(request.body());</span></a>
<a name="95"><span class="lineNum">      95 </span><span class="lineCov">          1 :       LOG(</span></a>
<a name="96"><span class="lineNum">      96 </span>            :           &quot; Server Rest API: Request add movie show  to database &quot;</a>
<a name="97"><span class="lineNum">      97 </span>            :           &lt;&lt; &quot; theater id = &quot; &lt;&lt; request_body[&quot;theaterId&quot;].ToString()</a>
<a name="98"><span class="lineNum">      98 </span>            :           &lt;&lt; &quot; movie id = &quot; &lt;&lt; request_body[&quot;movieId&quot;].ToString());</a>
<a name="99"><span class="lineNum">      99 </span>            :       // extract each needed field from the request,  then call MongoDbHandler to add the data</a>
<a name="100"><span class="lineNum">     100 </span><span class="lineCov">          1 :       bool insert_successful = mhandler.AddMovieShowToDb(</span></a>
<a name="101"><span class="lineNum">     101 </span><span class="lineCov">          2 :           request_body[&quot;theaterId&quot;].ToString(),</span></a>
<a name="102"><span class="lineNum">     102 </span><span class="lineCov">          2 :           request_body[&quot;movieId&quot;].ToString());</span></a>
<a name="103"><span class="lineNum">     103 </span>            : </a>
<a name="104"><span class="lineNum">     104 </span><span class="lineCov">          1 :       insert_successful ? served::response::stock_reply(201, response)</span></a>
<a name="105"><span class="lineNum">     105 </span><span class="lineNoCov">          0 :                         : served::response::stock_reply(400, response);</span></a>
<a name="106"><span class="lineNum">     106 </span><span class="lineCov">          2 :     };</span></a>
<a name="107"><span class="lineNum">     107 </span>            :   }</a>
<a name="108"><span class="lineNum">     108 </span>            : </a>
<a name="109"><span class="lineNum">     109 </span><span class="lineCov">          1 :   auto HttpServer::GetAllMovieShows()</span></a>
<a name="110"><span class="lineNum">     110 </span>            :   {</a>
<a name="111"><span class="lineNum">     111 </span><span class="lineCov">          1 :     return [&amp;](served::response &amp;response, const served::request &amp;request)</span></a>
<a name="112"><span class="lineNum">     112 </span>            :     {</a>
<a name="113"><span class="lineNum">     113 </span><span class="lineCov">          2 :       MongoDbHandler mhandler;</span></a>
<a name="114"><span class="lineNum">     114 </span><span class="lineCov">          1 :       LOG(&quot; Server Rest API: Request all movie shows&quot;);</span></a>
<a name="115"><span class="lineNum">     115 </span><span class="lineCov">          2 :       const json::JSON &amp;all_documents = mhandler.GetAllMovieShows();</span></a>
<a name="116"><span class="lineNum">     116 </span><span class="lineCov">          1 :       std::ostringstream stream;</span></a>
<a name="117"><span class="lineNum">     117 </span><span class="lineCov">          1 :       stream &lt;&lt; all_documents;</span></a>
<a name="118"><span class="lineNum">     118 </span><span class="lineCov">          1 :       response &lt;&lt; stream.str();</span></a>
<a name="119"><span class="lineNum">     119 </span><span class="lineCov">          2 :     };</span></a>
<a name="120"><span class="lineNum">     120 </span>            :   }</a>
<a name="121"><span class="lineNum">     121 </span>            : </a>
<a name="122"><span class="lineNum">     122 </span><span class="lineCov">          1 :   auto HttpServer::GetTheatersByMovie()</span></a>
<a name="123"><span class="lineNum">     123 </span>            :   {</a>
<a name="124"><span class="lineNum">     124 </span><span class="lineCov">          1 :     return [&amp;](served::response &amp;response, const served::request &amp;request)</span></a>
<a name="125"><span class="lineNum">     125 </span>            :     {</a>
<a name="126"><span class="lineNum">     126 </span><span class="lineCov">          2 :       MongoDbHandler mhandler;</span></a>
<a name="127"><span class="lineNum">     127 </span><span class="lineCov">          1 :       LOG(</span></a>
<a name="128"><span class="lineNum">     128 </span>            :           &quot; Server Rest API: Request get theater by movie &quot;</a>
<a name="129"><span class="lineNum">     129 </span>            :           &lt;&lt; &quot; movie id = &quot; &lt;&lt; request.params[&quot;movie_id&quot;]);</a>
<a name="130"><span class="lineNum">     130 </span><span class="lineCov">          2 :       const json::JSON &amp;all_documents = mhandler.GetTheatersByMovie(request.params[&quot;movie_id&quot;]);</span></a>
<a name="131"><span class="lineNum">     131 </span><span class="lineCov">          1 :       std::ostringstream stream;</span></a>
<a name="132"><span class="lineNum">     132 </span><span class="lineCov">          1 :       stream &lt;&lt; all_documents;</span></a>
<a name="133"><span class="lineNum">     133 </span><span class="lineCov">          1 :       response &lt;&lt; stream.str();</span></a>
<a name="134"><span class="lineNum">     134 </span><span class="lineCov">          2 :     };</span></a>
<a name="135"><span class="lineNum">     135 </span>            :   }</a>
<a name="136"><span class="lineNum">     136 </span>            : </a>
<a name="137"><span class="lineNum">     137 </span><span class="lineCov">          1 :   auto HttpServer::GetAvailableSeatsByMovieAndByTheater()</span></a>
<a name="138"><span class="lineNum">     138 </span>            :   {</a>
<a name="139"><span class="lineNum">     139 </span><span class="lineCov">          1 :     return [&amp;](served::response &amp;response, const served::request &amp;request)</span></a>
<a name="140"><span class="lineNum">     140 </span>            :     {</a>
<a name="141"><span class="lineNum">     141 </span><span class="lineCov">          2 :       MongoDbHandler mhandler;</span></a>
<a name="142"><span class="lineNum">     142 </span><span class="lineCov">          1 :       LOG(</span></a>
<a name="143"><span class="lineNum">     143 </span>            :           &quot; Server Rest API: Request get seats by movie and by theater &quot;</a>
<a name="144"><span class="lineNum">     144 </span>            :           &lt;&lt; &quot;movie_id = &quot; &lt;&lt; request.params[&quot;movie_id&quot;]</a>
<a name="145"><span class="lineNum">     145 </span>            :           &lt;&lt; &quot; theater_id = &quot; &lt;&lt; request.params[&quot;theater_id&quot;]);</a>
<a name="146"><span class="lineNum">     146 </span><span class="lineCov">          2 :       const json::JSON &amp;all_documents = mhandler.GetSeatsByMovieAndByTheater(request.params[&quot;movie_id&quot;], request.params[&quot;theater_id&quot;]);</span></a>
<a name="147"><span class="lineNum">     147 </span><span class="lineCov">          1 :       std::ostringstream stream;</span></a>
<a name="148"><span class="lineNum">     148 </span><span class="lineCov">          1 :       stream &lt;&lt; all_documents;</span></a>
<a name="149"><span class="lineNum">     149 </span><span class="lineCov">          1 :       response &lt;&lt; stream.str();</span></a>
<a name="150"><span class="lineNum">     150 </span><span class="lineCov">          2 :     };</span></a>
<a name="151"><span class="lineNum">     151 </span>            :   }</a>
<a name="152"><span class="lineNum">     152 </span>            : </a>
<a name="153"><span class="lineNum">     153 </span><span class="lineCov">          1 :   auto HttpServer::BookSeats()</span></a>
<a name="154"><span class="lineNum">     154 </span>            :   {</a>
<a name="155"><span class="lineNum">     155 </span><span class="lineCov">          2 :     return [&amp;](served::response &amp;response, const served::request &amp;request)</span></a>
<a name="156"><span class="lineNum">     156 </span>            :     {</a>
<a name="157"><span class="lineNum">     157 </span><span class="lineCov">          4 :       MongoDbHandler mhandler;</span></a>
<a name="158"><span class="lineNum">     158 </span><span class="lineCov">          4 :       json::JSON request_body_json = json::JSON::Load(request.body());</span></a>
<a name="159"><span class="lineNum">     159 </span><span class="lineCov">          2 :       LOG(</span></a>
<a name="160"><span class="lineNum">     160 </span>            :           &quot; Server Rest API: Book seats, seats ids list = &quot;</a>
<a name="161"><span class="lineNum">     161 </span>            :           &lt;&lt; request_body_json.dump());</a>
<a name="162"><span class="lineNum">     162 </span><span class="lineCov">          2 :       if (!BookSeatsRequestBodyValidation(request_body_json))</span></a>
<a name="163"><span class="lineNum">     163 </span>            :       {</a>
<a name="164"><span class="lineNum">     164 </span><span class="lineNoCov">          0 :         served::response::stock_reply(400, response);</span></a>
<a name="165"><span class="lineNum">     165 </span>            :       }</a>
<a name="166"><span class="lineNum">     166 </span>            :       else</a>
<a name="167"><span class="lineNum">     167 </span>            :       {</a>
<a name="168"><span class="lineNum">     168 </span>            : </a>
<a name="169"><span class="lineNum">     169 </span><span class="lineCov">          2 :         int number_of_seats_to_book = request_body_json.size();</span></a>
<a name="170"><span class="lineNum">     170 </span><span class="lineCov">          4 :         std::vector&lt;std::string&gt; seats_ids_list{};</span></a>
<a name="171"><span class="lineNum">     171 </span><span class="lineCov">          4 :         for (int i = 0; i &lt; number_of_seats_to_book; i++)</span></a>
<a name="172"><span class="lineNum">     172 </span>            :         {</a>
<a name="173"><span class="lineNum">     173 </span><span class="lineCov">          4 :           std::string seat_id = request_body_json.at(i).ToString();</span></a>
<a name="174"><span class="lineNum">     174 </span><span class="lineCov">          2 :           if (seat_id.size() != 0)</span></a>
<a name="175"><span class="lineNum">     175 </span>            :           {</a>
<a name="176"><span class="lineNum">     176 </span><span class="lineCov">          2 :             seats_ids_list.emplace_back(seat_id);</span></a>
<a name="177"><span class="lineNum">     177 </span>            :           }</a>
<a name="178"><span class="lineNum">     178 </span>            :         }</a>
<a name="179"><span class="lineNum">     179 </span>            : </a>
<a name="180"><span class="lineNum">     180 </span><span class="lineCov">          2 :         bool book_successful = mhandler.BookSeats(seats_ids_list);</span></a>
<a name="181"><span class="lineNum">     181 </span><span class="lineCov">          2 :         book_successful ? served::response::stock_reply(200, response)</span></a>
<a name="182"><span class="lineNum">     182 </span><span class="lineCov">          1 :                         : served::response::stock_reply(410, response);</span></a>
<a name="183"><span class="lineNum">     183 </span>            :       }</a>
<a name="184"><span class="lineNum">     184 </span><span class="lineCov">          3 :     };</span></a>
<a name="185"><span class="lineNum">     185 </span>            :   }</a>
<a name="186"><span class="lineNum">     186 </span>            : </a>
<a name="187"><span class="lineNum">     187 </span><span class="lineCov">          2 :   bool HttpServer::BookSeatsRequestBodyValidation(const json::JSON &amp;request_body_json)</span></a>
<a name="188"><span class="lineNum">     188 </span>            :   {</a>
<a name="189"><span class="lineNum">     189 </span>            :     // TODO robustness: maybe beter validation here if the body is not an array but a simple string.</a>
<a name="190"><span class="lineNum">     190 </span><span class="lineCov">          2 :     int number_of_seats_to_book = request_body_json.size();</span></a>
<a name="191"><span class="lineNum">     191 </span><span class="lineCov">          6 :     if (request_body_json.dump() == &quot;null&quot; or</span></a>
<a name="192"><span class="lineNum">     192 </span><span class="lineCov">          6 :         number_of_seats_to_book == 0 or</span></a>
<a name="193"><span class="lineNum">     193 </span><span class="lineCov">          4 :         request_body_json.hasKey(&quot;&quot;))</span></a>
<a name="194"><span class="lineNum">     194 </span>            :     {</a>
<a name="195"><span class="lineNum">     195 </span><span class="lineNoCov">          0 :       std::cerr &lt;&lt; &quot;BookSeatsRequestBody malformed &quot; &lt;&lt; std::endl;</span></a>
<a name="196"><span class="lineNum">     196 </span><span class="lineNoCov">          0 :       return false;</span></a>
<a name="197"><span class="lineNum">     197 </span>            :     }</a>
<a name="198"><span class="lineNum">     198 </span><span class="lineCov">          2 :     return true;</span></a>
<a name="199"><span class="lineNum">     199 </span>            :   }</a>
<a name="200"><span class="lineNum">     200 </span>            : </a>
<a name="201"><span class="lineNum">     201 </span>            :   // Public methods</a>
<a name="202"><span class="lineNum">     202 </span><span class="lineCov">          1 :   void HttpServer::InitializeEndpoints()</span></a>
<a name="203"><span class="lineNum">     203 </span>            :   {</a>
<a name="204"><span class="lineNum">     204 </span><span class="lineCov">          1 :     multiplexer.handle(ombsAddTheaterEndpoint).post(AddTheaterToMongoDb());</span></a>
<a name="205"><span class="lineNum">     205 </span><span class="lineCov">          1 :     multiplexer.handle(ombsAddMovieEndpoint).post(AddMovieToMongoDb());</span></a>
<a name="206"><span class="lineNum">     206 </span><span class="lineCov">          1 :     multiplexer.handle(ombsAddMovieShowEndpoint).post(AddMovieShowToMongoDb());</span></a>
<a name="207"><span class="lineNum">     207 </span><span class="lineCov">          1 :     multiplexer.handle(ombsBookSeatsEndpoint).post(BookSeats());</span></a>
<a name="208"><span class="lineNum">     208 </span>            : </a>
<a name="209"><span class="lineNum">     209 </span><span class="lineCov">          1 :     multiplexer.handle(ombsGetAvailableSeatsByMovieAndByTheaterEndpoint).get(GetAvailableSeatsByMovieAndByTheater());</span></a>
<a name="210"><span class="lineNum">     210 </span><span class="lineCov">          1 :     multiplexer.handle(ombsGetAllTheatersEndpoint).get(GetAllTheaters());</span></a>
<a name="211"><span class="lineNum">     211 </span><span class="lineCov">          1 :     multiplexer.handle(ombsGetAllMoviesEndpoint).get(GetAllMovies());</span></a>
<a name="212"><span class="lineNum">     212 </span>            : </a>
<a name="213"><span class="lineNum">     213 </span><span class="lineCov">          1 :     multiplexer.handle(ombsGetTheaterByMovieEndpoint).get(GetTheatersByMovie());</span></a>
<a name="214"><span class="lineNum">     214 </span><span class="lineCov">          1 :     multiplexer.handle(ombsGetAllMovieShowsEndpoint).get(GetAllMovieShows());</span></a>
<a name="215"><span class="lineNum">     215 </span><span class="lineCov">          1 :   }</span></a>
<a name="216"><span class="lineNum">     216 </span>            : </a>
<a name="217"><span class="lineNum">     217 </span>            : } // namespace omsb</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
